/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_ABSTRACT_FRAGMENTATION_SPLIT_VISITOR__
#define __DD_ABSTRACT_FRAGMENTATION_SPLIT_VISITOR__

#include "DDBitSplitVisitor.h"

namespace addibit {

    class AbstractFragmentationSplitVisitor : virtual public BitSplitVisitor {
    
        protected:
        virtual void registerContainer ( const unsigned int ) = 0;
        virtual void registerReference ( const struct RayReference &, const unsigned int ) {};     
        
        public:
        AbstractFragmentationSplitVisitor ( const unsigned int depth,
                                            const unsigned int capacity,
                                            const unsigned int fsize ) :
            BitSplitVisitor( depth, capacity, 2 ) {}
    };
}

#endif /* __DD_ABSTRACT_FRAGMENTATION_SPLIT_VISITOR__ */
