/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_ADJACENCY_TEST_STACK__
#define __DD_ADJACENCY_TEST_STACK__

#include "DDBitList.h"

namespace addibit {
    
    class AdjacencyTestStack {
    
        private:
        __BIT_LIST_RAW_DATA_TYPE__ __reg_1;
        uint_fast64_t __offset;
        __BIT_LIST_RAW_DATA_TYPE__ __data[ 1 ];
        
        public:
        AdjacencyTestStack () :
            __offset( 0 ) {}
            
         __attribute__((always_inline)) const __BIT_LIST_RAW_DATA_TYPE__ * start_ptr () const {
            return __data;
        }
        
         __attribute__((always_inline)) __BIT_LIST_RAW_DATA_TYPE__ * start_ptr () {
            return __data;
        }
        
         __attribute__((always_inline)) const __BIT_LIST_RAW_DATA_TYPE__ * current_ptr () const {
            return __data + __offset;
        }
        
         __attribute__((always_inline)) __BIT_LIST_RAW_DATA_TYPE__ * current_ptr () {
            return __data + __offset;
        }
        
        __attribute__((always_inline)) __BIT_LIST_RAW_DATA_TYPE__ * peek_and_push () {
            return __data + (__offset++) - 1;
        }
        
        __attribute__((always_inline)) const __BIT_LIST_RAW_DATA_TYPE__ * peek () const {
            return __data + __offset - 1;
        }
        
        __attribute__((always_inline)) const __BIT_LIST_RAW_DATA_TYPE__ * pop () {
            return __data + --__offset;
        }
        
        __attribute__((always_inline)) __BIT_LIST_RAW_DATA_TYPE__ * push ( const uint_fast16_t elements ) {
            __BIT_LIST_RAW_DATA_TYPE__ * __address = __data + __offset;
            __offset += elements;
            return __address;
        }
        
        __attribute__((always_inline)) void reset () {
            __offset = 0;
        }
        
        __attribute__((always_inline)) __BIT_LIST_RAW_DATA_TYPE__ reg_1 () const {
            return __reg_1;
        }
        
        __attribute__((always_inline)) void load_reg_1 ( const __BIT_LIST_RAW_DATA_TYPE__ value ) {
            __reg_1 = value;
        }
    };
}

#endif /* __DD_ADJACENCY_TEST_STACK__ */
