/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDAlgTestSingleSetRayCacheEntry.h"

using namespace addibit;

AlgTestSingleSetRayCacheEntry * AlgTestSingleSetRayCacheEntry::inequality_entry ( const uint_fast16_t rows,
                                                                                  const uint_fast16_t plane,
                                                                                  const BitList & pattern ) {
    return new InequalityAlgTestSingleSetRayCacheEntry( rows, plane, pattern );                          
}

AlgTestSingleSetRayCacheEntry * AlgTestSingleSetRayCacheEntry::inequality_entry ( const uint_fast16_t rows,
                                                                                  const uint_fast16_t plane,
                                                                                  const uint_fast16_t plane_coeff_offset,
                                                                                  const BitList & pattern ) {
    return new InequalityAlgTestSingleSetRayCacheEntry( rows, plane, plane_coeff_offset, pattern );                          
}

AlgTestSingleSetRayCacheEntry * AlgTestSingleSetRayCacheEntry::equality_entry ( const uint_fast16_t rows,
                                                                                const uint_fast16_t plane,
                                                                                const uint_fast16_t plane_coeff_offset,
                                                                                const BitList & pattern ) {
    return new EqualityAlgTestSingleSetRayCacheEntry( rows, plane, plane_coeff_offset, pattern );                          
}

inline bool InequalityAlgTestSingleSetRayCacheEntry::proceed ( std::shared_ptr<const SingleSetRay> ray ) {
    return ray->isOnThePlane( plane() ) || CacheEntry<SingleSetRay>::insert_narrow( ray );
}

inline bool EqualityAlgTestSingleSetRayCacheEntry::proceed ( std::shared_ptr<const SingleSetRay> ray ) {

    if ( !ray->isOnThePlane( plane() ) ) {
        CacheEntry<SingleSetRay>::insert_narrow( ray );
        return false;
    } else {
        return true;
    }
}
