/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_ALG_TEST_SINGLE_SET_RAY_CACHE_ENTRY__
#define __DD_ALG_TEST_SINGLE_SET_RAY_CACHE_ENTRY__

#include "DDSingleSetRay.h"
#include "DDCacheEntry.h"

namespace addibit {

	class AlgTestSingleSetRayCacheEntry : public CacheEntry<SingleSetRay> {

		public:
		AlgTestSingleSetRayCacheEntry ( const uint_fast16_t rows,
                               			const uint_fast16_t plane,
                                        const BitList & pattern ) :
			CacheEntry<SingleSetRay>( rows, plane, pattern ) {}
            
		AlgTestSingleSetRayCacheEntry ( const uint_fast16_t rows,
                               			const uint_fast16_t plane,
                                        const uint_fast16_t plane_coeff_offset,
                                        const BitList & pattern ) :
			CacheEntry<SingleSetRay>( rows, plane, plane_coeff_offset, pattern ) {}            

		virtual ~AlgTestSingleSetRayCacheEntry () {}   
        
        static AlgTestSingleSetRayCacheEntry * inequality_entry ( const uint_fast16_t, const uint_fast16_t, const BitList & );
		static AlgTestSingleSetRayCacheEntry * inequality_entry ( const uint_fast16_t, const uint_fast16_t, const uint_fast16_t, const BitList & );
		static AlgTestSingleSetRayCacheEntry * equality_entry ( const uint_fast16_t, const uint_fast16_t, const uint_fast16_t, const BitList & );                
	};
	
	class InequalityAlgTestSingleSetRayCacheEntry : public AlgTestSingleSetRayCacheEntry {
	
	    public:
	    InequalityAlgTestSingleSetRayCacheEntry ( const uint_fast16_t rows,
                                                  const uint_fast16_t plane,
                                                  const BitList & pattern ) :
            AlgTestSingleSetRayCacheEntry( rows, plane, pattern ) {}
            
	    InequalityAlgTestSingleSetRayCacheEntry ( const uint_fast16_t rows,
                                                  const uint_fast16_t plane,
                                                  const uint_fast16_t plane_coeff_offset,
                                                  const BitList & pattern ) :
            AlgTestSingleSetRayCacheEntry( rows, plane, plane_coeff_offset, pattern ) {}            
            
        ~InequalityAlgTestSingleSetRayCacheEntry () {}        
            
        bool proceed ( std::shared_ptr<const SingleSetRay> );    
	};
	
	class EqualityAlgTestSingleSetRayCacheEntry : public AlgTestSingleSetRayCacheEntry {
	
	    public:
	    EqualityAlgTestSingleSetRayCacheEntry ( const uint_fast16_t rows,
                                                const uint_fast16_t plane,
                                                const uint_fast16_t plane_coeff_offset,
                                                const BitList & pattern ) :
            AlgTestSingleSetRayCacheEntry( rows, plane, plane_coeff_offset, pattern ) {}
            
        ~EqualityAlgTestSingleSetRayCacheEntry () {}    
            
        bool proceed ( std::shared_ptr<const SingleSetRay> );    
	};	
}

#endif /* __DD_ALG_TEST_SINGLE_SET_RAY_CACHE_ENTRY__ */
