/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_BASIS_CACHE_ENTRY_NODE__
#define __DD_BASIS_CACHE_ENTRY_NODE__

#include "DDIntermediateCacheEntryNode.h"

namespace addibit {

    template <class RAY_TYPE, class CACHE_ENTRY_TYPE>
    class BasisCacheEntryNode : public IntermediateCacheEntryNode<RAY_TYPE, CACHE_ENTRY_TYPE> {
    
        public:
        BasisCacheEntryNode ( const unsigned int successors ) :
            IntermediateCacheEntryNode<RAY_TYPE, CACHE_ENTRY_TYPE>( NULL, successors ) {}
            
        ~BasisCacheEntryNode () {}
        
        const std::string toGraphVizString () const {
            std::stringstream result;
            
            result << "digraph RayCache {\n";
            result << IntermediateCacheEntryNode<RAY_TYPE, CACHE_ENTRY_TYPE>::toGraphVizString();
            result << "}\n";
            
            return result.str();
        }
    };
}

#endif /* __DD_BASIS_CACHE_ENTRY_NODE__ */
