/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_BINARY_DYNAMIC_VANTAGE_POINT_COMMON_POP_CNT_VISITOR__
#define __DD_BINARY_DYNAMIC_VANTAGE_POINT_COMMON_POP_CNT_VISITOR__

#include "DDBinaryDynamicVantagePointVisitor.h"

namespace addibit {

    class BinaryDynamicVantagePointCommonPopCntVisitor : public BinaryDynamicVantagePointVisitor {

        private:
        const unsigned int mMaxPopCnt;
        const bool mUniqueVP;

        protected:
        bool unique_vp () const {
            return mUniqueVP;
        }

        public:
        BinaryDynamicVantagePointCommonPopCntVisitor ( const unsigned int depth,
                                                       const unsigned int capacity,
                                                       const unsigned int max_pop_cnt,
                                                       const bool unique_vp = false ) :
            BinaryDynamicVantagePointVisitor( depth, capacity ),
            mMaxPopCnt( max_pop_cnt ),
            mUniqueVP( unique_vp ) {}

        bool can_proceed ( const RayReferenceContainer & container ) const {
            return container.max_pop_cnt() <= mMaxPopCnt;
        }
    };
}

#endif // __DD_BINARY_DYNAMIC_VANTAGE_POINT_COMMON_POP_CNT_VISITOR__
