/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_BINARY_FRAGMENTED_SINGLE_BIT_SPLIT_VISITOR__
#define __DD_BINARY_FRAGMENTED_SINGLE_BIT_SPLIT_VISITOR__

#include "DDAbstractFragmentedSingleBitSplitVisitor.h"
#include "DDBinaryFragmentationSplitVisitor.h"

namespace addibit {

    class BinaryFragmentedSingleBitSplitVisitor : public SingleBitSplitVisitor, public BinaryFragmentationSplitVisitor {   

        protected:    
        void registerContainer ( const unsigned int id ) {
            SingleBitSplitVisitor::registerContainer( id );
            BinaryFragmentationSplitVisitor::registerContainer( id );
        }        
        
        unsigned int getTargetContainer ( const RayReference & ref ) {
            const unsigned int c_index = SingleBitSplitVisitor::getTargetContainer( ref );
            registerReference( ref, set( c_index ).id() );
            return c_index;
        }            

        public:
        BinaryFragmentedSingleBitSplitVisitor ( const unsigned int depth,
                                                const unsigned int capacity,
                                                const BitSelectStrategy & strategy,
                                                const unsigned int fsize,
                                                const unsigned int blocks ) :
            BitSplitVisitor( depth, capacity, 2 ),
            SingleBitSplitVisitor( depth, capacity, strategy ),
            BinaryFragmentationSplitVisitor( depth, capacity, fsize, blocks ) {}
            
            
        void init ( const RayReferenceContainer & container ) {
            BinaryFragmentationSplitVisitor::init( container ); 
            container.iterate( SingleBitSplitVisitor::mContainerMapping );   
        }                   
          
        void refineCondition ( const uint_fast32_t index,
                               TwoBitsFragmentationCondition & cond ) const {

            BinaryFragmentationSplitVisitor::refineCondition( index, cond );
        }                       
    };
}

#endif /* __DD_BINARY_FRAGMENTED_SINGLE_BIT_SPLIT_VISITOR__ */
