/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_BINARY_FRAGMENTED_TWO_BITS_SPLIT_VISITOR__
#define __DD_BINARY_FRAGMENTED_TWO_BITS_SPLIT_VISITOR__

#include "DDBinaryFragmentationSplitVisitor.h"

namespace addibit {

    class BinaryFragmentedTwoBitsSplitVisitor : public BinaryFragmentationSplitVisitor {
    
        private:
        BitList mSplittingFragment;
    
        protected:
        unsigned int getTargetContainer ( const RayReference & ref ) {
            const unsigned int c_index = mSplittingFragment.getCommonPopCnt( mRefMapping[ ref.id ] );
            registerReference( ref, set( c_index ).id() );
            return c_index;
        }
    
        public:
        BinaryFragmentedTwoBitsSplitVisitor ( const unsigned int depth,
                                              const unsigned int capacity,
                                              const unsigned int blocks ) :
            BitSplitVisitor( depth, capacity, 3 ),
            BinaryFragmentationSplitVisitor( depth, capacity, 2, blocks ) {}       
            
        void before ( const RayReferenceContainer & container ) {
            BinaryFragmentationSplitVisitor::before( container );
            mSplittingFragment = mFragmentationMapping.findOpenFragment( container.id() );
        }            
                
        bool can_proceed ( const unsigned int index ) const {       
            return !mFragmentationMapping.findOpenFragment( set( index ).id() ).isEmpty();
        }                    
    };
}

#endif /* __DD_BINARY_FRAGMENTED_TWO_BITS_SPLIT_VISITOR__ */
