/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_BIT_REGISTER__
#define __DD_BIT_REGISTER__

#include "DDBitList.h"

namespace addibit {
	
	class BitRegister : public BitList {

		public:
		BitRegister () :
            BitList( __BIT_LIST_ALLOC_SPACE__ ) {}
            
		void getFirstCommonBit ( const BitList & map, uint_fast16_t & block, uint_fast16_t & position ) const {

			for ( block = 0; block < __DD_BLOCK_COUNT__; block++ ) {
				__BIT_LIST_RAW_DATA_TYPE__ block_data = getData( block ) & map[ block ];

				if ( block_data ) {
					position = __builtin_ctzl( block_data );
					break; 
				}
			}
		}

		inline __BIT_LIST_RAW_DATA_TYPE__ getOpAND ( const uint_fast16_t block, const __BIT_LIST_RAW_DATA_TYPE__ block_data ) const {
			return getData( block ) & block_data;
		}
	};
}

#endif // __DD_BIT_REGISTER__
