/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_CONDITIONED_RAY_REFERENCE_CONTAINER__
#define __DD_CONDITIONED_RAY_REFERENCE_CONTAINER__

#include "DDAbstractConditionedRayReferenceContainer.h"

namespace addibit {

    template<class CONDITION_TYPE>
    class ConditionedRayReferenceContainer : public AbstractConditionedRayReferenceContainer {
    
        private:
        const CONDITION_TYPE mCondition;
        
        public:
        ConditionedRayReferenceContainer ( RayReferenceContainer & container,
                                           CONDITION_TYPE && cond ) :
             AbstractConditionedRayReferenceContainer( container ),
             mCondition( std::move( cond ) ) {}
             
        const CONDITION_TYPE & condition () const {
            return mCondition;
        }
    };
}

#endif /* __DD_CONDITIONED_RAY_REFERENCE_CONTAINER__ */
