/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDContainerFragmentationMapping.h"

using namespace addibit;

uint_fast16_t ContainerFragmentationMapping::getNextOpenFragment ( const uint_fast32_t id ) const {
    
    const FragmentationData & __lower_bound = mLowerBound[ id ];
    const FragmentationData & __upper_bound = mUpperBound[ id ];
    
    FragmentationSegment result;
    uint_fast16_t findex = 0, i = 0;
    bool hit = false;
    
    do {
        result.__data = _mm_subs_epu8( __upper_bound[i].__data, __lower_bound[i].__data );
        for ( findex = 0;  findex < 16; findex++ ) {
            if (  result.__vec[ findex ] > 0 && __lower_bound[i].__vec[ findex ] < mTransformation.probabilities()[ i*findex ] && __upper_bound[i].__vec[ findex ] > mTransformation.probabilities()[ i*findex ] ) {
                hit = true;
                break;
            }
        }
    
    } while ( !hit && ++i < __upper_bound.segment_count() );
    
    return findex + i * __upper_bound.segment_count();
}
