
/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_EDGE_CANDIDATE__
#define __DD_EDGE_CANDIDATE__

#include "DDAdjacencyCandidate.h"
#include "DDAdjacencyTestStack.h"

namespace addibit {

    class EdgeCandidate {
        
        private:
        const uintptr_t __illegal_1;
        const uintptr_t __illegal_2;
        const AdjacencyCandidate & __adjacency_candidate;
        AdjacencyTestStack * const __stack;

        public:
        EdgeCandidate( const uintptr_t _illegal_1,
                       const uintptr_t _illegal_2,
                       const AdjacencyCandidate & adj_cand,
                       AdjacencyTestStack * const stack ) :
            __illegal_1( _illegal_1 ),
            __illegal_2( _illegal_2 ),
            __adjacency_candidate( adj_cand ),
            __stack( stack ) {}
        
        inline const __BIT_LIST_RAW_DATA_TYPE__ * data () const {
		    return __adjacency_candidate.data();
		}      
        
        inline const AdjacencyCandidate & adj_cand () const {
            return __adjacency_candidate;
        }
        
        inline AdjacencyTestStack * stack () {
            return __stack;
        }
        
        inline uintptr_t illegal_1 () const {
            return __illegal_1;
        }
        
        inline uintptr_t illegal_2 () const {
            return __illegal_2;
        }
        
        inline uint_fast16_t population () const {
            return __adjacency_candidate.population();
        }        
    };
}

#endif /* __DD_EDGE_CANDIDATE__ */
