/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_FIRST_AVAILABLE_BIT_STRATEGY__
#define __DD_FIRST_AVAILABLE_BIT_STRATEGY__

#include <vector>

#include "DDBitSelectStrategy.h"

namespace addibit {

    class FirstAvailableBitStrategy : public BitSelectStrategy {
        
        public:
        FirstAvailableBitStrategy ( const uint_fast16_t plane ) :
            BitSelectStrategy( plane ) {}     

        std::vector<unsigned int> createMapping () const {

            std::vector<unsigned int> mapping(mPlane);

            for ( uint_fast16_t index = 0; index < mPlane; index++ ) {
                mapping[index] = index;
            }

            return mapping;
        }
    };
}

#endif // __DD_FIRST_AVAILABLE_BIT_STRATEGY__
