/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDFragmentationSplitVisitor.h"

using namespace double_description;

const BitList * FragmentationSplitVisitor::createFragments ( const unsigned int size,
                                                             const unsigned int blocks ) const {

	BitList * fragments = new BitList[ mFragmentCount ];
	
	for ( unsigned int f_index = 0; f_index < mFragmentCount; f_index++ ) {
		fragments[ f_index ].resize( blocks );
		
		for ( unsigned int b_index = f_index * size; b_index < ( f_index + 1 ) * size; b_index++ ) {
		    fragments[ f_index ].setBit( b_index );
		}
	}
	
	return fragments;
}
