/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDFragmentationTransformation.h"
#include "DDBitSelector.h"

using namespace addibit;

const BitList * FragmentationTransformation::createFragments ( const BitSelectStrategy & strategy,
                                                               const unsigned int fsize,
                                                               const unsigned int fcount ) const {
                                                             
    BitSelector selector( strategy );
    BitList * result = new BitList[ fcount ];
    
    for ( uint_fast16_t findex = 0; findex < fcount; ++findex ) {
        result[ findex ] = selector.getNextNBits( fsize );
    }
    
    return result;
}

const std::string FragmentationTransformation::toString () const {
    std::stringstream output;
    
    for ( uint_fast16_t i = 0; i < mFragCount; ++i ) {
        output << mFragments[i].toString() << std::endl;
    }
    
    return output.str();
}
