/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDMaxZeroFirstSortCriterion.h"

using namespace addibit;

int MaxZeroFirstSortCriterion::cmp ( const CalculationVector & lhs, const CalculationVector & rhs ) const {

	short zeros_diff = 0;

	for ( unsigned int index = 0; index < lhs.getDimension(); index++ ) {
		if ( !lhs.isNonZeroAt( index ) ) {
			zeros_diff--;
		}
		if ( !rhs.isNonZeroAt( index ) ) {
			zeros_diff++;
		}
	}

	return zeros_diff;
}
