/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_NARROWING_CANDIDATE__
#define __DD_NARROWING_CANDIDATE__

#include "DDBitList.h"

namespace addibit {

    class NarrowingCandidate {
        
        private:
        uint64_t __popcount;
        __BIT_LIST_RAW_DATA_TYPE__ __data[ 1 ];
        
        public:
        NarrowingCandidate () :
            __popcount( 0 ) {}
            
        NarrowingCandidate ( const BitList & set ) :
            __popcount( set.getPopulationCount() ) {
            BitList::copy( set.data(), __data );
        }
        
         __attribute__((always_inline)) const __BIT_LIST_RAW_DATA_TYPE__ * data () const {
            return __data;
        }
        
         __attribute__((always_inline)) __BIT_LIST_RAW_DATA_TYPE__ * data () {
            return __data;
        }
        
    /*     __attribute__((always_inline)) const __BIT_LIST_RAW_DATA_TYPE__ * aux_data () const {
            return __data + __aux_offset;
        }
        
         __attribute__((always_inline)) __BIT_LIST_RAW_DATA_TYPE__ * aux_data () {
            return __data + __aux_offset;
        }
        
        __attribute__((always_inline)) __BIT_LIST_RAW_DATA_TYPE__ * peek_and_push_aux () {
            return __data + (__aux_offset++) - 1;
        }
        
        __attribute__((always_inline)) const __BIT_LIST_RAW_DATA_TYPE__ * peek_aux () const {
            return __data + __aux_offset - 1;
        }
        
        __attribute__((always_inline)) const __BIT_LIST_RAW_DATA_TYPE__ * pop_aux () {
            return __data + --__aux_offset;
        }
        
        __attribute__((always_inline)) __BIT_LIST_RAW_DATA_TYPE__ * push_aux ( const uint_fast16_t elements ) {
            __BIT_LIST_RAW_DATA_TYPE__ * __address = __data + __aux_offset;
            __aux_offset += elements;
            return __address;
        } */
        
         __attribute__((always_inline)) void load ( const BitList & set, const BitList & mask ) {
            __popcount = BitList::_op_cut_and_save( __data, set.data(), mask.data() );
        }
        
        inline uint_fast16_t common_pop_cnt ( const __BIT_LIST_RAW_DATA_TYPE__ * const __other ) const {
            return BitList::getCommonPopCnt( __data, __other );
        }
        
        inline uint_fast16_t population () const {
            return __popcount;
        }
        
        inline static uint_fast32_t dynamic_size () {
            return sizeof( NarrowingCandidate ) + sizeof( __BIT_LIST_RAW_DATA_TYPE__ ) * ( __DD_BLOCK_COUNT__ - 1 ) ;
        }
    };
}

#endif /* __DD_NARROWING_CANDIDATE__ */
