/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_OUTPUT_VECTOR__
#define __DD_OUTPUT_VECTOR__

#include <vector>
#include <string>

namespace addibit {

    template<class DATA_TYPE>
    class OutputVector {

        private:
        std::vector<DATA_TYPE> mData;

        public:
        OutputVector ( const unsigned int dim ) :
             mData( dim ) {}

        void setValue ( const unsigned int index, DATA_TYPE value ) {
            mData[ index ] = value;
        }

        void clear () {
            mData.clear();
        }

        const std::string toString () const {
	        std::stringstream output;

	        for ( unsigned int i = 0; i < mData.size(); i++ ) {
		        output << mData[ i ] << " ";
	        }

	        return output.str();
        }
    };
}

#endif
