
#ifndef __DD_PATTERN_GRAPH__
#define __DD_PATTERN_GRAPH__

#include "DDBitList.h"
#include "DDLogging.h"

namespace addibit {

	class PatternGraph {
		
		private:
		unsigned int ** mMap;
		unsigned int * mCount;

		unsigned int * mNodes;
		unsigned long mNodeCount;

#if defined _LP64 || defined __LP64__
		unsigned long fac ( const unsigned char n ) const;
#else
		unsigned long long fac ( const unsigned char n ) const;
#endif // _LP64 || defined __LP64__

		unsigned int getNodeCount ( const unsigned int depth, const unsigned int threshold ) const;
		
		public:
		PatternGraph ( const unsigned int depth, const unsigned int threshold );
		~PatternGraph ();

		unsigned int getEdgesCount ( const unsigned int src ) const {
			return mCount[src];
		}

		const unsigned int * getEdges ( const unsigned int src ) const {
			return mMap[src];
		}

		const unsigned int * getNodes () const {
			return mNodes;
		}

		unsigned int getNodesCount () const {
			return mNodeCount;
		}
	};
}

#endif // __DD_PATTERN_GRAPH__
