
#ifndef __DD_POP_TREE_CREATOR_UTILS__
#define __DD_POP_TREE_CREATOR_UTILS__

#include "DDSamplesContainer.h"
#include "DDTreeCreatorUtils.h"

namespace addibit {

    class PopTreeCreatorUtils : virtual public TreeCreatorUtils {
        
        private:
        const SamplesContainer & mSamples;

        public:
        PopTreeCreatorUtils( const unsigned int maxElementsPerLeaf,
                             const BitList & cutMap,
                             const SamplesContainer & samples ) :
            TreeCreatorUtils( maxElementsPerLeaf, cutMap ),
            mSamples( samples ) {}
    
        const SamplesContainer & samples () const {
            return mSamples;
        }        
    };
}

#endif // __DD_POP_TREE_CREATOR_UTILS__
