/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_RAY_REF_VISITOR__
#define __DD_RAY_REF_VISITOR__

#include "DDRayReference.h"

namespace addibit {

    class RayRefVisitor {

        public:
        virtual ~RayRefVisitor () {}

        virtual void onStart () {};
        virtual void onVisit ( const RayReference & ) = 0;
        virtual void onFinish () {};
        
        virtual bool needsInitRound () const {
            return false;
        }
        virtual void onInitStart () {}
        virtual void onInitVisit ( const RayReference & ) {}
    };
}

#endif // __DD_RAY_REF_VISITOR__
