/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDTreeNode.h"

using namespace addibit;

void TreeNode::toFile ( const std::string & file_name,
                        const uint_fast16_t depth ) const {

    std::fstream graph_file( file_name.c_str(), std::fstream::out );        

    graph_file << "digraph { " << std::endl
               << toGraphVizString( depth ) << std::endl
               << "}";

    graph_file.close();
}

void TreeNode::toFile ( const char * prefix,
                        const uint_fast16_t suffix,
                        const uint_fast16_t depth ) const {
                            
    std::stringstream name_stream;
    name_stream << prefix << "_" << suffix << ".dot";
    toFile( name_stream.str(), depth );
}

const std::string TreeNode::toString () const {
    std::stringstream result;
    
    result << "|V|=" << getRaysCount();
    
    return result.str();
}
