/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDTwoBitsFragmentationCondition.h"

using namespace addibit;


const BitList TwoBitsFragmentationCondition::createReductionMap ( const unsigned int fcount,
                                                                  const BitList * const & fragments,
                                                                  const Interval * const & bounds ) const {
    BitList reduction( __BIT_LIST_ALLOC_SPACE__, 0 );
    
    for ( unsigned int f_index = 0; f_index < fcount; f_index++ ) {
 
        if ( bounds[ f_index ].ub() == __FRAGMENT_SIZE__ - 1 && union_map().getCommonPopCnt( fragments[ f_index ] ) == __FRAGMENT_SIZE__ ) {
            reduction.setBit( __FRAGMENT_SIZE__ * f_index + 1 );
        }
    }
                                       
    return reduction;
}
