/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_ZERO_FREQUENCY_MODIFIER__
#define __DD_ZERO_FREQUENCY_MODIFIER__

#include "DDFrequencyModifier.h"

namespace addibit {

    class ZeroFrequencyModifier : public FrequencyModifier {

        private:
        const unsigned long mMax;

        protected:
        unsigned long update ( const unsigned long index, const bool value ) const {
            return value ? 0 : mMax - mPopulation[ index ].count();
        }

        public:
        ZeroFrequencyModifier( const std::vector<BitPopulationEntry> & population,
                               const unsigned long max ) :
            FrequencyModifier( population ),
            mMax( max ) {}
    };
}

#endif // __DD_ZERO_FREQUENCY_MODIFIER__
